import java.awt.Color;
import java.awt.Font;
import java.awt.FontMetrics;
import java.awt.Graphics;

/**
 * Java applet displaying properties
 * 
 * @author Bernard Bou
 */
public class JavaVersion extends java.applet.Applet
{
	private static final long serialVersionUID = 1L;

	/**
	 * Properties to retrieve
	 */
	static private String[] theNames = new String[] { "java.version", "java.vendor", "java.vendor.url", "java.specification.name", "java.specification.version", "java.specification.vendor", "java.vm.name", "java.vm.version", "java.vm.vendor",
			"java.vm.specification.name", "java.vm.specification.version", "java.vm.specification.vendor" };

	/**
	 * Properties
	 */
	static String[] theseProps = JavaVersion.getProps();

	/**
	 * Get properties
	 * 
	 * @return string array
	 */
	static private String[] getProps()
	{
		final String[] thisResult = new String[JavaVersion.theNames.length];
		String thisProp;
		for (int i = 0; i < JavaVersion.theNames.length; i++)
		{
			thisProp = JavaVersion.theNames[i] + " : ";
			try
			{
				thisProp += System.getProperty(JavaVersion.theNames[i]);
			}
			catch (final SecurityException e)
			{
				thisProp += "<protected>";
			}
			catch (final Exception e)
			{
				thisProp += "<>";
			}
			thisResult[i] = thisProp;
		}
		return thisResult;
	}

	/**
	 * Get data
	 * 
	 * @return data as string
	 */
	public String getData()
	{
		final StringBuffer thisBuffer = new StringBuffer();
		for (final String thisTheseProp : JavaVersion.theseProps)
		{
			thisBuffer.append(thisTheseProp);
			thisBuffer.append("\n");
		}
		return thisBuffer.toString();
	}

	/*
	 * (non-Javadoc)
	 * @see java.awt.Container#paint(java.awt.Graphics)
	 */
	@Override
	public void paint(final Graphics thisGraphics)
	{
		thisGraphics.setColor(Color.black);
		final String[] theProps = JavaVersion.getProps();

		thisGraphics.setFont(new Font("SansSerif", Font.PLAIN, 10));
		final FontMetrics fm = thisGraphics.getFontMetrics();
		final int h = fm.getAscent() + fm.getDescent();
		int y = h;
		for (final String thisTheProp : theProps)
		{
			thisGraphics.drawString(thisTheProp, 10, y);
			y += h;
		}
	}
}
