/**
 * Title :	Property view
 * Description: Property editor
 * Version:	provider
 * Copyright (c) 2001-2008
 * Terms of use:see license agreement at http://treebolic.sourceforge.net/en/license.htm
 * Author: Bernard Bou
 * Company: bsys
 */
package bsys.propertyview;

import java.awt.Component;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.AbstractCellEditor;
import javax.swing.JButton;
import javax.swing.JTable;
import javax.swing.SwingConstants;
import javax.swing.table.TableCellEditor;

/**
 * File editor
 * 
 * @author Bernard Bou
 */
class LongTextEditor extends AbstractCellEditor implements TableCellEditor
{
	private static final long serialVersionUID = 1L;

	/**
	 * Text
	 */
	private String theText;

	/**
	 * Dialog
	 */
	private final TextDialog theTextDialog;

	/**
	 * Button component
	 */
	private final JButton theButton;

	/**
	 * Constructor
	 */
	public LongTextEditor()
	{
		this.theButton = new JButton();
		this.theButton.setBorderPainted(false);
		this.theButton.setHorizontalAlignment(SwingConstants.LEFT);
		this.theButton.addActionListener(new ActionListener()
		{
			@SuppressWarnings("synthetic-access")
			@Override
			public void actionPerformed(final ActionEvent e)
			{
				LongTextEditor.this.theTextDialog.setText(LongTextEditor.this.theText);
				LongTextEditor.this.theTextDialog.setModal(true);
				LongTextEditor.this.theTextDialog.setVisible(true);

				// dialog returns control
				fireEditingStopped();
			}
		});

		// text
		this.theTextDialog = new TextDialog( //

				// ok listener
				new ActionListener()
				{
					@SuppressWarnings("synthetic-access")
					@Override
					public void actionPerformed(final ActionEvent e)
					{
						fireEditingStopped();
					}
				},

				// cancel
				new ActionListener()
				{
					@SuppressWarnings("synthetic-access")
					@Override
					public void actionPerformed(final ActionEvent e)
					{
						fireEditingCanceled();
					}
				});
	}

	// I N T E R F A C E

	/*
	 * (non-Javadoc)
	 * @see javax.swing.table.TableCellEditor#getTableCellEditorComponent(javax.swing.JTable, java.lang.Object, boolean, int, int)
	 */
	@Override
	public Component getTableCellEditorComponent(final JTable thisTable, final Object thisValue, final boolean thisIsSelected, final int thisRow, final int thisColumn)
	{
		this.theText = (String) thisValue;
		this.theButton.setText(this.theText);
		return this.theButton;
	}

	/*
	 * (non-Javadoc)
	 * @see javax.swing.CellEditor#getCellEditorValue()
	 */
	@Override
	public Object getCellEditorValue()
	{
		final String thisText = this.theTextDialog.getText();
		return thisText == null || thisText.isEmpty() ? null : thisText;
	}
}
