/*
 * Generated by XDoclet - Do not edit!
 */
package edu.princeton.wordnet.interfaces;

/**
 * Remote interface for WordNet.
 * 
 * @author Bernard Bou
 */
public interface WordNet extends javax.ejb.EJBObject
{
	/**
	 * Business method that returns WordNet data as a Document
	 * 
	 * @param thisWord
	 *        is the target word
	 * @param withLinks
	 *        determines if queries are to include links
	 * @param recurse
	 *        determines if queries are to follow links recursively
	 * @return WordNet data as a DOM Document
	 */
	public org.w3c.dom.Document queryDoc(java.lang.String thisWord, boolean withLinks, boolean recurse) throws java.rmi.RemoteException;

	/**
	 * Business method that returns complete data as XML
	 * 
	 * @param thisWord
	 *        is the target word
	 * @param withLinks
	 *        determines if queries are to include links
	 * @param recurse
	 *        determines if queries are to follow links recursively
	 * @return WordNet data as XML
	 */
	public java.lang.String queryXML(java.lang.String thisWord, boolean withLinks, boolean recurse) throws java.rmi.RemoteException;

	/**
	 * Business method that returns WordNet overview data as DOM document
	 * 
	 * @param thisWord
	 *        is the target word
	 * @param thisPosName
	 *        is the target part-of-speech
	 * @param thisCategoryName
	 *        is the target category
	 * @param thisLinkName
	 *        is the target link type
	 * @param withLinks
	 *        determines if queries are to include links
	 * @param recurse
	 *        determines if queries are to follow links recursively
	 * @return WordNet overview data as DOM document
	 */
	public org.w3c.dom.Document queryDoc(java.lang.String thisWord, java.lang.String thisPosName, java.lang.String thisCategoryName, java.lang.String thisLinkName, boolean withLinks, boolean recurse) throws java.rmi.RemoteException;

	/**
	 * Business method that returns WordNet overview data as XML
	 * 
	 * @param thisWord
	 *        is the target word
	 * @param thisPosName
	 *        is the target part-of-speech
	 * @param thisCategoryName
	 *        is the target category
	 * @param thisLinkName
	 *        is the target link type
	 * @param withLinks
	 *        determines if queries are to include links
	 * @param recurse
	 *        determines if queries are to follow links recursively
	 * @return WordNet overview data as XML data
	 */
	public java.lang.String queryXML(java.lang.String thisWord, java.lang.String thisPosName, java.lang.String thisCategoryName, java.lang.String thisLinkName, boolean withLinks, boolean recurse) throws java.rmi.RemoteException;

	/**
	 * Business method that returns WordNet overview data as DOM document
	 * 
	 * @param thisWord
	 *        is the target word
	 * @return WordNet overview data as DOM document
	 */
	public org.w3c.dom.Document queryOverviewDoc(java.lang.String thisWord) throws java.rmi.RemoteException;

	/**
	 * Business method that returns WordNet overview data as XML
	 * 
	 * @param thisWord
	 *        is the target word
	 * @return WordNet overview data as XML
	 */
	public java.lang.String queryOverviewXML(java.lang.String thisWord) throws java.rmi.RemoteException;

	/**
	 * Business method that returns XWordNet data as DOM document
	 * 
	 * @param thisSynsetId
	 *        is the target synset id
	 * @return XWordNet data as DOM document
	 */
	public org.w3c.dom.Document queryDocXWn(long thisSynsetId) throws java.rmi.RemoteException;

	/**
	 * Business method returns XWordNet data as XML data
	 * 
	 * @param thisSynsetId
	 *        is the target synset id
	 * @return XWordNet data as XML data
	 */
	public java.lang.String queryXMLXWn(long thisSynsetId) throws java.rmi.RemoteException;

	/**
	 * Business method that returns XWordNet overview data as DOM document
	 * 
	 * @param thisWord
	 *        is the target word
	 * @return XWordNet overview as DOM document
	 */
	public org.w3c.dom.Document queryDocWnXWn(java.lang.String thisWord) throws java.rmi.RemoteException;

	/**
	 * Business method that returns XWordNet overview data as XML
	 * 
	 * @param thisWord
	 *        is the target word
	 * @return XWordNet overview data as XML
	 */
	public java.lang.String queryXMLWnXWn(java.lang.String thisWord) throws java.rmi.RemoteException;

	/**
	 * Business method that returns VerbNet data as DOM document
	 * 
	 * @param thisWordId
	 *        is the word id to build query from
	 * @param thisSynsetId
	 *        is the synset id to build query from (-1 if any)
	 * @return VerbNet data as DOM document
	 */
	public org.w3c.dom.Document queryDocVn(long thisWordId, long thisSynsetId) throws java.rmi.RemoteException;

	/**
	 * Business method that returns VerbNet data as XML
	 * 
	 * @param thisWordId
	 *        is the target word id
	 * @param thisSynsetId
	 *        is the target synset id (-1 if any)
	 * @return VerbNet data as XML
	 */
	public java.lang.String queryXMLVn(long thisWordId, long thisSynsetId) throws java.rmi.RemoteException;

	/**
	 * Business method the returns VerbNet overview data as DOM document
	 * 
	 * @param thisWord
	 *        is the target word
	 * @return VerbNet overview data as DOM document
	 */
	public org.w3c.dom.Document queryDocWnVn(java.lang.String thisWord) throws java.rmi.RemoteException;

	/**
	 * Business method that returns XWordnet overview data as XML
	 * 
	 * @param thisWord
	 *        is the target word
	 * @return VerbNet overview data as XML
	 */
	public java.lang.String queryXMLWnVn(java.lang.String thisWord) throws java.rmi.RemoteException;

}
