/**
 * Title : Treebolic application
 * Description: Treebolic application
 * Version: 2.x
 * Copyright:	(c) 2001-2008
 * Terms of use:see license agreement at http://treebolic.sourceforge.net/en/license.htm
 * Author: Bernard Bou
 * Company: bsys
 */
package treebolic;

import java.awt.Color;
import java.awt.Component;
import java.awt.Font;

import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.SwingConstants;
import javax.swing.WindowConstants;

/**
 * About dialog
 * 
 * @author Bernard Bou
 */
public class AboutDialog extends JDialog
{
	private static final long serialVersionUID = 1L;

	/**
	 * Constructor
	 */
	public AboutDialog()
	{
		super();
		initialize();
	}

	/**
	 * Initialize
	 */
	private void initialize()
	{
		final JLabel thisTitle = new JLabel();
		thisTitle.setText("Treebolic");
		thisTitle.setFont(new Font("Dialog", 1, 18));
		thisTitle.setOpaque(true);
		thisTitle.setBackground(Color.RED);
		thisTitle.setForeground(Color.WHITE);
		thisTitle.setHorizontalAlignment(SwingConstants.CENTER);
		thisTitle.setAlignmentX(Component.CENTER_ALIGNMENT);

		final JLabel thisDescription = new JLabel();
		thisDescription.setText("Treebolic application");
		thisDescription.setFont(new Font("Dialog", 0, 10));
		thisDescription.setHorizontalAlignment(SwingConstants.CENTER);
		thisDescription.setAlignmentX(Component.CENTER_ALIGNMENT);

		final JLabel thisVersion = new JLabel();
		thisVersion.setText("version 2.0");
		thisVersion.setFont(new Font("Dialog", 0, 10));
		thisVersion.setHorizontalAlignment(SwingConstants.CENTER);
		thisVersion.setAlignmentX(Component.CENTER_ALIGNMENT);

		final JLabel thisAuthor = new JLabel();
		thisAuthor.setText("Bernard Bou <bbou@ac-toulouse.fr>");
		thisAuthor.setFont(new Font("Dialog", 0, 10));
		thisAuthor.setHorizontalAlignment(SwingConstants.CENTER);
		thisAuthor.setAlignmentX(Component.CENTER_ALIGNMENT);

		final JPanel thisPanel = new JPanel();
		thisPanel.setAlignmentX(Component.RIGHT_ALIGNMENT);
		final BoxLayout thisLayout = new BoxLayout(thisPanel, BoxLayout.Y_AXIS);
		thisPanel.setLayout(thisLayout);
		thisPanel.add(Box.createVerticalGlue());
		thisPanel.add(thisTitle);
		thisPanel.add(Box.createVerticalGlue());
		thisPanel.add(thisDescription);
		thisPanel.add(thisVersion);
		thisPanel.add(thisAuthor);

		setContentPane(thisPanel);
		pack();
	}

	/**
	 * Main
	 * 
	 * @param theseArgs
	 *        arguments
	 */
	static public void main(final String[] theseArgs)
	{
		final AboutDialog thisDialog = new AboutDialog();
		thisDialog.setModal(true);
		thisDialog.setVisible(true);
		thisDialog.setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
		System.exit(0);
	}
}
