/**
 * Title :	Treebolic generator
 * Description: Treebolic generator
 * Version:	provider
 * Copyright (c) 2001-2008
 * Terms of use:see license agreement at http://treebolic.sourceforge.net/en/license.htm
 * Author: Bernard Bou
 * Company: bsys
 */
package treebolic;

import treebolic.commons.Laf;
import treebolic.generator.MainFrame;

/**
 * Generator
 * 
 * @author Bernard Bou
 */
public class Generator
{
	/**
	 * Version
	 */
	static private final String theVersion = "provider"; //$NON-NLS-1$

	/**
	 * Constructor
	 * 
	 * @param theseArgs
	 *        program arguments
	 */
	public Generator(final String[] theseArgs)
	{
		// System.out.println("CLASSPATH=<" + System.getProperty("java.class.path", ".") + ">");

		// laf
		Laf.lookAndFeel(theseArgs);

		new MainFrame(theseArgs);
	}

	/**
	 * Get version
	 * 
	 * @return version
	 */
	static public String getVersion()
	{
		return Generator.theVersion;
	}

	/**
	 * Main
	 * 
	 * @param theseArgs
	 *        aruments
	 */
	public static void main(final String[] theseArgs)
	{
		Laf.lookAndFeel(theseArgs);
		new Generator(theseArgs);
	}
}