/**
 * Title : Treebolic
 * Description: Treebolic
 * Version: 2.x
 * Copyright:	(c) 2001-2008
 * Terms of use:see license agreement at http://treebolic.sourceforge.net/en/license.htm
 * Author: Bernard Bou
 * Company: bsys
 */
package treebolic.commons;

import java.io.File;
import java.net.MalformedURLException;

/**
 * Help
 * 
 * @author Bernard Bou
 */
public class Help
{
	/**
	 * Help
	 * 
	 * @param thisBrowser
	 *        browser
	 * @param thatHelp
	 *        help url string
	 */
	static public void help(final String thisBrowser, final String thatHelp)
	{
		String thisHelp = thatHelp;
		if (!thisHelp.startsWith("file:")) //$NON-NLS-1$
		{
			final File thisFolder = new File(thisHelp);
			try
			{
				thisHelp = thisFolder.toURI().toURL().toString();
			}
			catch (final MalformedURLException thisException)
			{
				return;
			}
		}
		if (!thisHelp.endsWith("/"))
		{
			thisHelp += "/"; //$NON-NLS-1$
		}
		thisHelp += "index.html"; //$NON-NLS-1$
		Help.run(thisBrowser + " " + thisHelp); //$NON-NLS-1$
	}

	/**
	 * Run command as separate process
	 * 
	 * @param thisCommand
	 *        command line
	 */
	static private void run(final String thisCommand)
	{
		if (thisCommand != null && thisCommand != null)
		{
			try
			{
				Runtime.getRuntime().exec(thisCommand);
			}
			catch (final Exception e)
			{
				System.err.println("Cannot run " + thisCommand + " " + e.toString()); //$NON-NLS-1$ //$NON-NLS-2$
			}
		}
	}
}
