/**
 * Title : Treebolic
 * Description: Treebolic
 * Version: 2.x
 * Copyright:	(c) 2001-2008
 * Terms of use:see license agreement at http://treebolic.sourceforge.net/en/license.htm
 * Author: Bernard Bou
 * Company: bsys
 */
package treebolic.commons;

/**
 * Java version
 * 
 * @author Bernard Bou
 */
public class JavaVersion
{
	/**
	 * The names of properties
	 */
	static private String[] theNames = new String[] { "java.version", "java.vendor", "java.vendor.url", "java.specification.name", "java.specification.version", "java.specification.vendor", "java.vm.name", "java.vm.version", "java.vm.vendor", //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$ //$NON-NLS-6$ //$NON-NLS-7$ //$NON-NLS-8$ //$NON-NLS-9$
			"java.vm.specification.name", "java.vm.specification.version", "java.vm.specification.vendor" }; //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$

	/**
	 * Get property values
	 * 
	 * @return string array of name=value pairs
	 */
	static public String[] getJavaProps()
	{
		final String[] thisResult = new String[JavaVersion.theNames.length];

		String thisProp;
		for (int i = 0; i < JavaVersion.theNames.length; i++)
		{
			thisProp = JavaVersion.theNames[i] + " : "; //$NON-NLS-1$
			try
			{
				thisProp += System.getProperty(JavaVersion.theNames[i]);
			}
			catch (final SecurityException e)
			{
				thisProp += "<protected>"; //$NON-NLS-1$
			}
			catch (final Exception e)
			{
				thisProp += "<>"; //$NON-NLS-1$
			}
			thisResult[i] = thisProp;
		}
		return thisResult;
	}

	/**
	 * Get property values as string
	 * 
	 * @return s string
	 */
	static public String getJavaPropsString()
	{
		final String[] theseStrings = JavaVersion.getJavaProps();
		final StringBuffer thisBuffer = new StringBuffer();
		for (final String thisString : theseStrings)
		{
			thisBuffer.append(thisString);
			thisBuffer.append("\n"); //$NON-NLS-1$
		}
		return thisBuffer.toString();
	}

	/**
	 * Main
	 * 
	 * @param theseArgs
	 *        arguments
	 */
	static public void main(final String[] theseArgs)
	{
		final String[] theseProps = JavaVersion.getJavaProps();
		for (final String thisTheseProp : theseProps)
		{
			System.out.println(thisTheseProp);
		}
	}
}
