/**
 * Title : Treebolic
 * Description: Treebolic
 * Version: 2.x
 * Copyright:	(c) 2001-2008
 * Terms of use:see license agreement at http://treebolic.sourceforge.net/en/license.htm
 * Author: Bernard Bou
 * Company: bsys
 */
package treebolic.commons;

import java.awt.Component;
import java.awt.Dimension;
import java.awt.Toolkit;

/**
 * Utilities
 * 
 * @author Bernard Bou
 */
public class Utils
{
	// C E N T E R

	/**
	 * Center on screen
	 * 
	 * @param thisComponent
	 *        component to center
	 */
	static public void center(final Component thisComponent)
	{
		final Dimension thisScreenSize = Toolkit.getDefaultToolkit().getScreenSize();
		final Dimension thisComponentSize = thisComponent.getSize();
		if (thisComponentSize.height > thisScreenSize.height)
		{
			thisComponentSize.height = thisScreenSize.height;
		}
		if (thisComponentSize.width > thisScreenSize.width)
		{
			thisComponentSize.width = thisScreenSize.width;
		}
		thisComponent.setLocation((thisScreenSize.width - thisComponentSize.width) / 2, (thisScreenSize.height - thisComponentSize.height) / 2);
	}
}
