/**
 * Title :	Treebolic generator
 * Description: Treebolic generator
 * Version:	provider
 * Copyright (c) 2001-2008
 * Terms of use:see license agreement at http://treebolic.sourceforge.net/en/license.htm
 * Author: Bernard Bou
 * Company: bsys
 */
package treebolic.dialogs.main;

import java.util.Properties;

import javax.swing.UIManager;
import javax.swing.WindowConstants;

import treebolic.commons.OpenDialog;
import treebolic.commons.Persist;

/**
 * Open dialog
 * 
 * @author Bernard Bou
 */
public class XOpenDialog extends OpenDialog
{
	private static final long serialVersionUID = 1L;

	/**
	 * Constructor
	 * 
	 * @param theseProperties
	 *        properties
	 */
	public XOpenDialog(final Properties theseProperties)
	{
		super(theseProperties);
	}

	/**
	 * Main
	 * 
	 * @param theseArgs
	 *        argumes
	 */
	static public void main(final String[] theseArgs)
	{
		UIManager.put("swing.boldMetal", false); //$NON-NLS-1$
		final Properties theseSettings = Persist.getSettings("treebolic-generator"); //$NON-NLS-1$
		final XOpenDialog thisDialog = new XOpenDialog(theseSettings);
		thisDialog.setModal(true);
		thisDialog.setVisible(true);
		thisDialog.setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
		if (thisDialog.ok)
		{
			Persist.saveSettings("treebolic-generator", theseSettings); //$NON-NLS-1$
		}
		System.exit(0);
	}
}
