/**
 * Title : Treebolic
 * Description: Treebolic
 * Version: 2.x
 * Copyright:	(c) 2001-2008
 * Terms of use:see license agreement at http://treebolic.sourceforge.net/en/license.htm
 * Author: Bernard Bou
 * Company: bsys
 */
package treebolic.generator;

import java.awt.Dimension;
import java.util.Map;
import java.util.SortedSet;

import treebolic.Messages;
import treebolic.generator.model.ModelUtils;

/**
 * Mount list dialog
 * 
 * @author Bernard Bou
 */
public class MountListDialog extends ReferenceListDialog
{
	private static final long serialVersionUID = 1L;

	/**
	 * Constructor
	 */
	public MountListDialog(final Controller thisController)
	{
		super(thisController);
		setTitle(Messages.getString("MountListDialog.0")); //$NON-NLS-1$
		this.theLabel.setText(Messages.getString("MountListDialog.1")); //$NON-NLS-1$
		this.theScrollPane.setPreferredSize(new Dimension(300, 120));
	}

	/*
	 * (non-Javadoc)
	 * @see treebolic.generator.ReferenceListDialog#update()
	 */
	@Override
	protected void update()
	{
		final Map<String, SortedSet<String>> thisMountToLocationMap = ModelUtils.getMountMap(this.theController.getModel());
		setModel(thisMountToLocationMap);
		super.update();
	}
}
