/**
 * Title :	Treebolic generator
 * Description: Treebolic generator
 * Version:	provider
 * Copyright (c) 2001-2008
 * Terms of use:see license agreement at http://treebolic.sourceforge.net/en/license.htm
 * Author: Bernard Bou
 * Company: bsys
 */
package treebolic.generator.domtree.treebolic;

import org.w3c.dom.Node;

import treebolic.generator.domtree.ElementDecorator;

/**
 * (Treebolic) node node decorator
 * 
 * @author Bernard Bou
 */
public class NodeDecorator extends ElementDecorator
{
	// C O N S T R U C T O R

	/**
	 * Constructor
	 * 
	 * @param thisNode
	 *        DOM node
	 */
	public NodeDecorator(final Node thisNode)
	{
		super(thisNode);
	}

	// S T R I N G S

	/*
	 * (non-Javadoc)
	 * @see treebolic.generator.domtree.ElementDecorator#getName()
	 */
	@Override
	public String getName()
	{
		return " " + super.getName() + " "; //$NON-NLS-1$ //$NON-NLS-2$
	}

	/*
	 * (non-Javadoc)
	 * @see treebolic.generator.domtree.ElementDecorator#getValue()
	 */
	@Override
	public String getValue()
	{
		return super.getValue();
	}
}
