/**
 * Title :	Treebolic generator
 * Description: Treebolic generator
 * Version:	provider
 * Copyright (c) 2001-2008
 * Terms of use:see license agreement at http://treebolic.sourceforge.net/en/license.htm
 * Author: Bernard Bou
 * Company: bsys
 */
package treebolic.generator.tree;

import java.util.List;

import treebolic.model.IEdge;
import treebolic.model.Model;
import treebolic.model.Settings;

/**
 * Edges wrapper
 * 
 * @author Bernard Bou
 */
public class EdgesWrapper extends SettingsWrapper
{
	/**
	 * Edge list
	 */
	public List<IEdge> theEdgeList;

	/**
	 * Model (as container of edges list)
	 */
	public Model theModel;

	/**
	 * Constructor
	 * 
	 * @param thisEdgeList
	 *        edge list
	 * @param thisModel
	 *        model
	 * @param theseSettings
	 *        settings
	 */
	public EdgesWrapper(final List<IEdge> thisEdgeList, final Model thisModel, final Settings theseSettings)
	{
		super(theseSettings);
		this.theEdgeList = thisEdgeList;
		this.theModel = thisModel;
	}
}
