/**
 * Title: Hyperbolic engine
 * Description: Treebolic Engine
 * Version: provider
 * Copyright: (c) 2001-2008
 * Terms of use:see license agreement at http://treebolic.sourceforge.net/en/license.htm
 * Author: Bernard Bou
 * Company: bsys
 * Update: Mon Mar 10 00:00:00 CEST 2008
 */
package treebolic.model;

import java.net.URL;

/**
 * Provider context
 * 
 * @author Bernard Bou
 */
public interface IProviderContext
{
	/**
	 * Make URL from source string
	 * 
	 * @param thisSource
	 * @return URL or null
	 */
	public URL makeURL(String thisSource);

	/**
	 * Get parameter
	 * 
	 * @param thisName
	 *        parameter name
	 * @return parameter value
	 */
	public String getParameter(String thisName);

	/**
	 * Put progress
	 * 
	 * @param thisString
	 *        message
	 */
	public void putProgress(String thisString, boolean fail);

	/**
	 * Put status string (such as error)
	 * 
	 * @param thisString
	 *        message
	 */
	public void putMessage(String thisString);
}
