/**
 * Title: Hyperbolic engine
 * Description: Treebolic Engine
 * Version: provider
 * Copyright: (c) 2001-2008
 * Terms of use:see license agreement at http://treebolic.sourceforge.net/en/license.htm
 * Author: Bernard Bou
 * Company: bsys
 * Update: Mon Mar 10 00:00:00 CEST 2008
 */
package treebolic.model;

import treebolic.core.EuclidianLocation;
import treebolic.core.HyperLocation;

/**
 * Node location in hyperspace and unit circle mapping
 * 
 * @author Bernard Bou
 */
public class Location
{
	// H Y P E R S P A C E

	/**
	 * Hyper location
	 */
	public final HyperLocation hyper;

	// E U C L I D I A N . U N I T C I R C L E

	/**
	 * Unit circle location
	 */
	public final EuclidianLocation euclidian;

	// V I E W D A T A

	/**
	 * Opaque view rendering data
	 */
	public Object theViewData;

	// C O N S T R U C T O R

	/**
	 * Construct
	 */
	public Location()
	{
		this.hyper = new HyperLocation();
		this.euclidian = new EuclidianLocation();
	}

	// T O . U N I T . C I R C L E

	/**
	 * Map hyperspace to unit circle euclidian space
	 */
	public void mapToUnitCircle()
	{
		this.euclidian.set(this.hyper);

		// flag computation state
		this.hyper.isDirty = false;
	}
}
