/**
 * Title: Hyperbolic engine
 * Description: Treebolic Engine
 * Version: provider
 * Copyright: (c) 2001-2008
 * Terms of use:see license agreement at http://treebolic.sourceforge.net/en/license.htm
 * Author: Bernard Bou
 * Company: bsys
 * Update: Mon Mar 10 00:00:00 CEST 2008
 */
package treebolic.model;

import java.util.List;

/**
 * Mount point
 * 
 * @author Bernard Bou
 */
public class MountPoint
{
	static public class Mounting extends MountPoint
	{
		/**
		 * URL
		 */
		public String theURL;

		/**
		 * Mount now (for editing only)
		 */
		public Boolean now;

		/**
		 * Saved allocated half wedge
		 */
		public double theHalfWedge;

		/**
		 * Saved orientation
		 */
		public double theOrientation;

		/**
		 * Mounted node reference
		 */
		public INode theMountedNode;

		/**
		 * Constructor
		 */
		@SuppressWarnings("synthetic-access")
		public Mounting()
		{
			super();
			this.theURL = null;
			this.theHalfWedge = 0.;
			this.theOrientation = 0.;
			this.theMountedNode = null;
		}
	}

	static public class Mounted extends MountPoint
	{
		/**
		 * Mounting node reference
		 */
		public INode theMountingNode;

		/**
		 * Mounted edges
		 */
		public List<IEdge> theMountedEdges;

		/**
		 * Constructor
		 */
		@SuppressWarnings("synthetic-access")
		public Mounted()
		{
			super();
			this.theMountingNode = null;
			this.theMountedEdges = null;
		}
	}

	/**
	 * Constructor
	 */
	private MountPoint()
	{
		// do nothing
	}
}
