/**
 * Title: Treebolic
 * Description: Treebolic mutable
 * Version: provider
 * Copyright: (c) 2001-2008
 * Terms of use:see license agreement at http://treebolic.sourceforge.net/en/license.htm
 * Author: Bernard Bou
 * Company: bsys
 * Update: Mon Mar 10 00:00:00 CEST 2008
 */
package treebolic.model;

import java.awt.Color;

/**
 * Mutable edge
 * 
 * @author Bernard Bou
 */
public class MutableEdge extends Edge
{
	/**
	 * Construct node
	 * 
	 * @param thisFromNode
	 *        from node
	 * @param thisToNode
	 *        to node
	 */
	public MutableEdge(final INode thisFromNode, final INode thisToNode)
	{
		super(thisFromNode, thisToNode);
	}

	/**
	 * Set label
	 * 
	 * @param thisLabel
	 *        label
	 */
	public void setLabel(final String thisLabel)
	{
		this.theLabel = thisLabel;
	}

	/**
	 * Set color
	 * 
	 * @param thisColor
	 *        color
	 */
	public void setColor(final Color thisColor)
	{
		this.theColor = thisColor;
	}

	/**
	 * Set style
	 * 
	 * @param thisStyle
	 *        edge style
	 */
	public void setStyle(final Integer thisStyle)
	{
		this.theStyle = thisStyle;
	}

	/**
	 * Set image filename
	 * 
	 * @param thisImageFile
	 *        image filename
	 */
	public void setImageFile(final String thisImageFile)
	{
		this.theImageFile = thisImageFile;
	}
}
