/**
 * Title: Treebolic
 * Description: Treebolic mutable
 * Version: provider
 * Copyright: (c) 2001-2008
 * Terms of use:see license agreement at http://treebolic.sourceforge.net/en/license.htm
 * Author: Bernard Bou
 * Company: bsys
 * Update: Mon Mar 10 00:00:00 CEST 2008
 */
package treebolic.model;

import java.awt.Color;

/**
 * Mutable node
 * 
 * @author Bernard Bou
 */
public class MutableNode extends Node
{
	/**
	 * Constructor
	 * 
	 * @param thisParent
	 *        parent
	 * @param thisId
	 *        id
	 */
	public MutableNode(final INode thisParent, final String thisId)
	{
		super(thisParent, thisId);
	}

	/**
	 * Set label
	 * 
	 * @param thisLabel
	 *        label
	 */
	public void setLabel(final String thisLabel)
	{
		this.theLabel = thisLabel;
	}

	/**
	 * Set content
	 * 
	 * @param thisContent
	 *        content
	 */
	public void setContent(final String thisContent)
	{
		this.theContent = thisContent;
	}

	/**
	 * Set backcolor
	 * 
	 * @param thisColor
	 *        backcolor
	 */
	public void setBackColor(final Color thisColor)
	{
		this.theBackColor = thisColor;
	}

	/**
	 * Set forecolor
	 * 
	 * @param thisColor
	 *        forecolor
	 */
	public void setForeColor(final Color thisColor)
	{
		this.theForeColor = thisColor;
	}

	/**
	 * Set node image file
	 * 
	 * @param thisImageFile
	 *        image file
	 */
	public void setImageFile(final String thisImageFile)
	{
		this.theImageFile = thisImageFile;
	}

	/**
	 * Set edge label
	 * 
	 * @param thisLabel
	 *        edge label
	 */
	public void setEdgeLabel(final String thisLabel)
	{
		this.theEdgeLabel = thisLabel;
	}

	/**
	 * Set edge style
	 * 
	 * @param thisStyle
	 *        style
	 */
	public void setEdgeStyle(final Integer thisStyle)
	{
		this.theEdgeStyle = thisStyle;
	}

	/**
	 * Set edge color
	 * 
	 * @param thisColor
	 *        color
	 */
	public void setEdgeColor(final Color thisColor)
	{
		this.theEdgeColor = thisColor;
	}

	/**
	 * Set edge image file
	 * 
	 * @param thisImageFile
	 *        image file
	 */
	public void setEdgeImageFile(final String thisImageFile)
	{
		this.theEdgeImageFile = thisImageFile;
	}

	/**
	 * Set node link URL
	 * 
	 * @param thisLink
	 *        link URL
	 */
	public void setLink(final String thisLink)
	{
		this.theLink = thisLink;
	}

	/**
	 * Set node link target frame
	 * 
	 * @param thisTarget
	 *        link target frame
	 */
	public void setTarget(final String thisTarget)
	{
		this.theTarget = thisTarget;
	}
}
