/**
 * Title: Treebolic SQL provider
 * Description: Treebolic SQL provider
 * Version: 2.x
 * Copyright: (c) 2001-2008
 * Terms of use:see license agreement at http://treebolic.sourceforge.net/en/license.htm
 * Author: Bernard Bou
 * Company: bsys
 */
package treebolic.provider.sql;

import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.net.URL;
import java.util.Enumeration;
import java.util.Properties;

/**
 * SQL properties
 * 
 * @author Bernard Bou
 */
public class SqlProperties
{
	/**
	 * Load properties
	 */
	static public Properties load(final URL thisUrl)
	{
		try
		{
			final Properties theseProperties = new Properties();
			final InputStream thisInputStream = thisUrl.openStream();
			theseProperties.load(thisInputStream);
			return theseProperties;
		}
		catch (final IOException e)
		{
			System.err.println("Sql: Cannot load <" + thisUrl.toString() + ">");
			return null;
		}
	}

	/**
	 * Save properties
	 */
	static void save(final Properties theseProperties, final String thisPropertyFile)
	{
		try
		{
			theseProperties.store(new FileOutputStream(thisPropertyFile), "TREEBOLIC-SQL");
		}
		catch (final IOException e)
		{
			e.printStackTrace();
		}
	}

	/**
	 * Make default property
	 */
	static public String toString(final Properties theseProperties)
	{
		final StringBuffer thisBuffer = new StringBuffer();
		for (final Enumeration<?> thisEnum = theseProperties.propertyNames(); thisEnum.hasMoreElements();)
		{
			final String thisName = (String) thisEnum.nextElement();
			final String thisValue = theseProperties.getProperty(thisName);
			thisBuffer.append(thisName);
			thisBuffer.append("=");
			thisBuffer.append(thisValue);
			thisBuffer.append("\n");
		}
		return thisBuffer.toString();
	}
}
