/**
 * Title: Treebolic WordNet provider
 * Description: Treebolic WordNet Provider
 * Version: 2.x
 * Copyright: (c) 2001-2008
 * Terms of use:see license agreement at http://treebolic.sourceforge.net/en/license.htm
 * Author: Bernard Bou
 * Company: bsys
 */
package treebolic.provider.wn;

import java.awt.Color;
import java.awt.Image;
import java.util.Random;

/**
 * Node
 * 
 * @author Bernard Bou
 */
public class Node extends treebolic.model.MutableNode
{
	// id factory

	/**
	 * Randomize used to generate ids
	 */
	static private Random theRandomizer = new Random();

	/**
	 * Make node id
	 * 
	 * @return node id
	 */
	static public String makeNodeId()
	{
		return "X" + Long.toHexString(theRandomizer.nextLong());
	}

	/**
	 * Constructor
	 * 
	 * @param thisParentNode
	 *        parent node
	 * @param thisLabel
	 *        label
	 * @param thisImage
	 *        image
	 * @param thisBackColor
	 *        backcolor
	 * @param thisForeColor
	 *        forecolor
	 */
	public Node(Node thisParentNode, String thisLabel, Image thisImage, Color thisBackColor, Color thisForeColor)
	{
		super(thisParentNode, makeNodeId());
		setLabel(thisLabel);
		setBackColor(thisBackColor);
		setForeColor(thisForeColor);
		setImage(thisImage);
	}
}
