/**
 * Title: Treebolic WordNet provider
 * Description: Treebolic WordNet Provider
 * Version: 2.x
 * Copyright: (c) 2001-2008
 * Terms of use:see license agreement at http://treebolic.sourceforge.net/en/license.htm
 * Author: Bernard Bou
 * Company: bsys
 */
package treebolic.provider.wn;

import java.awt.Color;

import edu.princeton.wordnet.WordNet;

/**
 * Part of Speech node
 * 
 * @author Bernard Bou
 */
public class PosNode extends Node
{
	/**
	 * Background color
	 */
	private static final Color thePosBackColor = Color.WHITE;

	/**
	 * Foreground color
	 */
	private static final Color thePosForeColor = Color.BLUE;

	/**
	 * Constructor
	 * 
	 * @param thisParentNode
	 *        parent node
	 * @param thisIdx
	 *        pos index
	 */
	public PosNode(Node thisParentNode, int thisIdx)
	{
		super(thisParentNode, WordNet.thePosString[thisIdx], null, thePosBackColor, thePosForeColor);
		setEdgeLabel("pos");
	}
}
