/**
 * Title: Treebolic WordNet provider
 * Description: Treebolic WordNet Provider
 * Version: 2.x
 * Copyright: (c) 2001-2008
 * Terms of use:see license agreement at http://treebolic.sourceforge.net/en/license.htm
 * Author: Bernard Bou
 * Company: bsys
 */
package treebolic.provider.wn;

import java.awt.Color;
import java.awt.Image;

import javax.swing.ImageIcon;

import edu.princeton.wordnet.Synset;

/**
 * Sense node
 * 
 * @author Bernard Bou
 */
public class SenseNode extends Node
{
	/**
	 * Synset
	 */
	private Synset theSynset;

	/**
	 * Image
	 */
	private static final Image theImage = new ImageIcon(SenseNode.class.getResource("images/sense.gif")).getImage();

	/**
	 * Background color
	 */
	private static final Color theSenseBackColor = Color.WHITE;

	/**
	 * Foreground color
	 */
	private static final Color theSenseForeColor = Color.MAGENTA;

	/**
	 * Constructor
	 * 
	 * @param thisParentNode
	 *        parent node
	 * @param thisSenseIdx
	 *        sense index
	 * @param thisSynset
	 *        synset
	 */
	public SenseNode(Node thisParentNode, int thisSenseIdx, Synset thisSynset)
	{
		super(thisParentNode, Integer.toString(thisSenseIdx), theImage, theSenseBackColor, theSenseForeColor);
		theSynset = thisSynset;
		setEdgeLabel("sense");
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see treebolic.node.INode#getContent()
	 */
	public String getContent()
	{
		return theSynset != null ? theSynset.defn : theLabel;
	}
}
