/**
 * Title: Treebolic GXML provider
 * Description: Treebolic GXML graph provider
 * Version: 2.x
 * Copyright: (c) 2001-2008
 * Terms of use: see license agreement at http://treebolic.sourceforge.net/en/license.htm
 * Author: Bernard Bou
 * Company: bsys
 */
package treebolic.provider.xml.graph.gxml;

import treebolic.model.IProvider;
import treebolic.provider.xml.graph.AbstractParser;

/**
 * Provider factory for GXL provider
 * 
 * @author Bernard Bou
 */
public class Provider extends treebolic.provider.xml.graph.AbstractProvider implements IProvider
{
	/*
	 * (non-Javadoc)
	 * @see treebolic.provider.graph.Provider#getSource(java.lang.String)
	 */
	@Override
	public String getSource(final String thisSource)
	{
		// get xml file
		String thisGxlFile = thisSource;
		if (thisGxlFile == null)
		{
			thisGxlFile = this.theContext.getParameter("gxml");
		}
		return thisGxlFile;
	}

	/*
	 * (non-Javadoc)
	 * @see treebolic.provider.graph.Provider#getParser()
	 */
	@Override
	public AbstractParser getParser()
	{
		return new GxmlParser();
	}
}
