/**
 * Title: Treebolic XSLT GXL provider
 * Description: Treebolic provider using XSL-transformed GXL file
 * Version: provider
 * Copyright: (c) 2001-2008
 * Terms of use:see license agreement at http://treebolic.sourceforge.net/en/license.htm
 * Author: Bernard Bou
 * Company: bsys
 */
package treebolic.provider.xslt.gxl;

import java.net.URL;

/**
 * Provider for GXL (through XSL).
 * 
 * @author Bernard Bou
 */
public class Provider extends treebolic.provider.xslt.Provider
{
	/*
	 * (non-Javadoc)
	 * @see treebolic.provider.xslt.Provider#getDtdUrl()
	 */
	@Override
	protected URL getDtdUrl()
	{
		return Provider.class.getResource("gxl-1.0.dtd");
	}

	/*
	 * (non-Javadoc)
	 * @see treebolic.provider.xslt.Provider#getXsltUrl()
	 */
	@SuppressWarnings("static-access")
	@Override
	protected URL getXsltUrl()
	{
		return Provider.class.getResource(Provider.docToDoc ? "gxl2treebolic-d2d.xsl" : "gxl2treebolic.xsl");
	}
}
