/**
 * Title: Treebolic WordNetprovider
 * Description: Treebolic provider using XSL-transformed WordNet file
 * Version: provider
 * Copyright: (c) 2001-2008
 * Terms of use:see license agreement at http://treebolic.sourceforge.net/en/license.htm
 * Author: Bernard Bou
 * Company: bsys
 */
package treebolic.provider.xslt.wordnet;

import java.net.URL;

/**
 * Provider for WordNet (through XSL)
 * 
 * @author Bernard Bou
 */
public class Provider extends treebolic.provider.xslt.Provider
{
	/*
	 * (non-Javadoc)
	 * @see treebolic.provider.xslt.Provider#getDtdUrl()
	 */
	@Override
	protected URL getDtdUrl()
	{
		return Provider.class.getResource("WordNet.dtd");
	}

	/*
	 * (non-Javadoc)
	 * @see treebolic.provider.xslt.Provider#getXsltUrl()
	 */
	@Override
	protected URL getXsltUrl()
	{
		return Provider.class.getResource("wordnet2treebolic.xsl");
	}
}
